#!/usr/local/bin/python3.6
#####################################################################################
###
### Acme Software Works, Inc.
###
### Created June 16, 2019 by Don Dugger
###
### <PRE>
### Copyright 2019 Acme Software Works, Inc.
### 
### Redistribution and use in source and binary forms, with or without
### modification, are permitted provided that the following conditions are met:
### 
### 1. Redistributions of source code must retain the above copyright notice,
###    this list of conditions and the following disclaimer.
### 
### 2. Redistributions in binary form must reproduce the above copyright notice,
###    this list of conditions and the following disclaimer in the documentation
###    and/or other materials provided with the distribution.
### 
### THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
### AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
### IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
### ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
### LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
### CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
### GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
### HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
### LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
### OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
### <PRE>
#####################################################################################
from datetime import datetime
from dateutil.relativedelta import relativedelta
from promptdb import PromptDB
from libprompt import BIN_DIR
from libprompt import sayit
import sys
import subprocess


##################### Main ###############################
#
# This program is a single loop which goes through all the
# prompts in the database and if they are due, says so and
# then executes the 'prompt' program.
#

db = PromptDB()
# Get the list of prompts.
prompt_list = db.fetchAllPrompts()
for prompt in prompt_list:
    # Get the due date and time of the task
    prompt_datetime = datetime.strptime(str(prompt[1]) + " " + str(prompt[2]),"%Y-%m-%d %H:%M:%S")
    # Move a head 5 minutes so the prompt happens just before the time setting 
    now = datetime.today() + relativedelta(minutes=+6)
    if now > prompt_datetime: # Is the task due?
        # Say so
        sayit("A task is due")
        # Display the task prompt
        id_str = '-i{}'.format(prompt[0])
        args = [BIN_DIR+'prompt.py',id_str]
        res = subprocess.run(args)

